import React, { Suspense } from 'react'
import { Physics } from '@react-three/cannon'

import World from './models/World'
import WorldCollisions from './models/WorldCollisions'
import Player from './Player'
import Lighting from './Lighting'
import Effects from './Effects'
import Controls from './Controls'
import Users from './Users'

const Scene: React.FC = () => {
  return (
    <>
      <Lighting />

      <Suspense fallback={null}>
        <World />
        <Physics
          gravity={[0, 0, 0]}
          iterations={2}
          size={2}
          defaultContactMaterial={{
            friction: 0,
            restitution: 0,
          }}
        >
          <WorldCollisions />
          <Player />
        </Physics>
        <Effects />
      </Suspense>
      <Users />

      <Controls />
    </>
  )
}

export default Scene
